src/main/java/br/com/home/gestor/controller/ColecoesController.java
package br.com.home.gestor.controller;

import static br.com.home.gestor.util.Constantes.BR;

import java.io.Serializable;
import java.text.DateFormatSymbols;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.inject.Inject;
import javax.inject.Named;

import org.springframework.context.annotation.Scope;

import br.com.home.gestor.modelo.Categoria;
import br.com.home.gestor.modelo.Mes;
import br.com.home.gestor.modelo.PeriodicidadeFixa;
import br.com.home.gestor.modelo.PeriodicidadeParcelada;
import br.com.home.gestor.modelo.StatusItemDesejado;
import br.com.home.gestor.modelo.TipoLancamento;
import br.com.home.gestor.modelo.TipoPagamento;
import br.com.home.gestor.service.CategoriaService;
import br.com.home.gestor.service.TipoPagamentoService;

import com.google.common.collect.Lists;

@Named
@Scope("view")
public class ColecoesController implements Serializable{

	@Inject
	private CategoriaService categoriaService;
	
	@Inject
	private TipoPagamentoService tipoPagamentoService;
	
	private List<Categoria> categorias;
	
	private List<TipoPagamento> tiposPagamento;
	
	private List<Integer> numeroParcelas;
	
	private List<Mes> meses = Lists.newArrayList();
	
	private List<StatusItemDesejado> statusItensDesejados = Arrays.asList(StatusItemDesejado.values());
	
	
	@PostConstruct
	protected void init(){
		numeroParcelas = new ArrayList<Integer>();	
		for(int i = 2; i <= 20; i++){
			numeroParcelas.add(i);
		}
		
		String[] arrayMeses = new DateFormatSymbols(BR).getShortMonths();
		for(int i = 0; i < arrayMeses.length-1; i++){
			meses.add(new Mes(i+1, arrayMeses[i]));
		}
	}
	
	
	public List<TipoPagamento> getTiposPagamento() {
		if(tiposPagamento == null){
			tiposPagamento = tipoPagamentoService.findAll();
		}
		return tiposPagamento;
	}
	
	public List<Categoria> getCategorias() {
		
		if(categorias == null){
			categorias = categoriaService.findAll();
			
			Collections.sort(categorias, new Comparator<Categoria>() {

				@Override
				public int compare(Categoria c1, Categoria c2) {
					return c1.getNome().compareToIgnoreCase(c2.getNome());
				}
				
			});
		}
		
		return categorias;
	}
	
	public List<TipoLancamento> getTiposLancamento() {
		return Arrays.asList(TipoLancamento.values());
	}
	
	public List<PeriodicidadeFixa> getPeriodicidadeFixas(){
		return Arrays.asList(PeriodicidadeFixa.values());
	}
	
	public List<PeriodicidadeParcelada> getPeriodicidadeParceladas(){
		return Arrays.asList(PeriodicidadeParcelada.values());
	}
	
	public List<Integer> getNumeroParcelas() {
		return numeroParcelas;
	}
	
	public List<Mes> getMeses() {
		return meses;
	}
	
	public List<StatusItemDesejado> getStatusItensDesejados() {
		return statusItensDesejados;
	}
}

src/main/java/br/com/home/gestor/controller/LancamentoController.java
package br.com.home.gestor.controller;

import br.com.home.gestor.modelo.Categoria;
import br.com.home.gestor.modelo.Lancamento;
import br.com.home.gestor.modelo.LancamentoFixo;
import br.com.home.gestor.service.LancamentoFixoService;
import br.com.home.gestor.service.LancamentoService;
import br.com.home.gestor.util.faces.JsfUtil;
import org.springframework.context.annotation.Scope;
import org.springframework.util.StringUtils;

import javax.faces.event.AjaxBehaviorEvent;
import javax.inject.Inject;
import javax.inject.Named;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

@Named
@Scope("view")
public class LancamentoController implements Serializable{

	@Inject
	private LancamentoService lancamentoService;

	@Inject
    private LancamentoFixoService lancamentoFixoService;

	private Lancamento lancamento;
	
	private int numeroParcelas;
	
	private TipoParcelamento tipoParcelamentoSelecionado;
	
	private boolean repeticao;
	
	private boolean alterarEsteEPosteriores;
	
	private boolean alterarTodosLancamentos;
	
	private Categoria categoria;
	
	private Categoria categoriaARemover;

    private Long lancamentoId;
	
	public enum TipoParcelamento{
		FIXO("é um lançamento fixo"),
		PARCELADO("é um lançamento parcelado");
		
		private TipoParcelamento(String tipo){
			this.tipo = tipo;
		}
		
		private final String tipo;
		
		public String getTipo() {
			return tipo;
		}
	}

	public void init(){
		novoLancamento();

		if(lancamentoId != null){
			lancamento = lancamentoService.findById(lancamentoId);
			if(lancamento.getPeriodicidadeParcelada() != null){
				tipoParcelamentoSelecionado = TipoParcelamento.PARCELADO;
				numeroParcelas = lancamento.getNumeroParcela();
//				falta tratar como a edicao de um lancamento parcelado
				// deve editar apenas os lancamentos que ainda estão com data maior a atual, e colocar um aviso, tentar usar o alert do bootstrap
			}
			categoria = new ArrayList<Categoria>(lancamento.getCategorias()).get(0);
			repeticao = (lancamento.getPeriodicidadeFixa() != null) || (lancamento.getPeriodicidadeParcelada() != null) && isMostraRepetir();
		}
	}
		
	public void novoLancamento(){
		lancamento = Lancamento.novo();
		tipoParcelamentoSelecionado = null;
		categoria = null;
		repeticao = false;
	}
	
	public void cancelar(){
		novoLancamento();
	}
	
	public void adicionaCategoria(){
		if(categoria != null){
			lancamento.adicionaCategoria(categoria);
			categoria = null;
		}
	}
	
	public void removeCategoria(){
			lancamento.removeCategoria(categoriaARemover);
			categoriaARemover = null;
	}
	
	protected boolean isValido(){
		boolean resultado = true;
		
		if(lancamento.getTipoLancamento() == null){
			JsfUtil.addWarMessage("Informe o tipo de lançamento(entrada/saída)");
			resultado = false;
		}
		
		if(!StringUtils.hasText(lancamento.getDescricao())){
			JsfUtil.addWarMessage("A descrição deve ser informada");
			resultado = false;
		}
		
		if(lancamento.getValor() == null || BigDecimal.ZERO.equals(lancamento.getValor())){
			JsfUtil.addWarMessage("O valor deve ser informado");
			resultado = false;
		}
		
		if(lancamento.getDataLancamento() == null){
			JsfUtil.addWarMessage("A data do lançamento deve ser informada");
			resultado = false;
		}
		if(lancamento.getCategorias().isEmpty()){
			JsfUtil.addWarMessage("Ao menos uma categoria deve ser informada");
			resultado = false;
		}
		
		if(lancamento.getTipoPagamento() == null){
			JsfUtil.addWarMessage("O modo de pagamento deve ser informado");
			resultado = false;
		}
		
		return resultado;
	}
	
	public void salvar(){

		if(!isValido()){
			return;
		}
		if(!repeticao){
			lancamento.setPeriodicidadeFixa(null);
			lancamento.setPeriodicidadeParcelada(null);
		}
		
		if(tipoParcelamentoSelecionado != null && isRepeticao()){
			if(TipoParcelamento.FIXO.equals(tipoParcelamentoSelecionado)){
                lancamentoFixoService.save(LancamentoFixo.fromLancamento(lancamento));

			}else if(TipoParcelamento.PARCELADO.equals(tipoParcelamentoSelecionado)){
				int parcelaInicial = 1;
				if(!isNovo(lancamento) && alterarEsteEPosteriores){
					parcelaInicial = lancamento.getNumeroParcela();
				}
				lancamentoService.registraLancamentoParcelado(lancamento, parcelaInicial, numeroParcelas);
			}
		}else{
			lancamentoService.registraLancamento(lancamento);
		}
		JsfUtil.addInfoMessage("Lançamento salvo");
		novoLancamento();
	}
	
	public Lancamento getLancamento() {
		return lancamento;
	}

	public void setLancamento(Lancamento lancamento) {
		this.lancamento = lancamento;
	}
	
	private boolean isNovo(Lancamento lancamento){
		return lancamento.getId() != null;
	}


	public int getNumeroParcelas() {
		return numeroParcelas;
	}

	public void setNumeroParcelas(int numeroParcelas) {
		this.numeroParcelas = numeroParcelas;
	}
	
	public List<TipoParcelamento> getTiposParcelamento(){
		return Arrays.asList(TipoParcelamento.values());
	}

	public boolean isRepeticao() {
		return repeticao;
	}

	public void setRepeticao(boolean repeticao) {
		this.repeticao = repeticao;
	}
	
	public boolean isMostraRepetir(){
		return lancamento.getId() == null && !TipoParcelamento.PARCELADO.equals(tipoParcelamentoSelecionado);
	}
	
	public boolean isEdicaoLancamentoParcelado(){
		return lancamento.getId() != null && TipoParcelamento.PARCELADO.equals(tipoParcelamentoSelecionado);
	}
	
	public boolean isMostraPanelRepeticaoFixo(){
		return isMostraRepetir() && isRepeticao() && TipoParcelamento.FIXO.equals(tipoParcelamentoSelecionado);
	}
	
	public boolean isMostraPanelRepeticaoParcelado(){
		return isRepeticao() && TipoParcelamento.PARCELADO.equals(tipoParcelamentoSelecionado);
	}

	public TipoParcelamento getTipoParcelamentoSelecionado() {
		return tipoParcelamentoSelecionado;
	}

	public void setTipoParcelamentoSelecionado(
			TipoParcelamento tipoParcelamentoSelecionado) {
		this.tipoParcelamentoSelecionado = tipoParcelamentoSelecionado;
	}

	public boolean isAlterarEsteEPosteriores() {
		return alterarEsteEPosteriores;
	}

	public void setAlterarEsteEPosteriores(boolean alterarEsteEPosteriores) {
		this.alterarEsteEPosteriores = alterarEsteEPosteriores;
	}

	public boolean isAlterarTodosLancamentos() {
		return alterarTodosLancamentos;
	}

	public void setAlterarTodosLancamentos(boolean alterarTodosLancamentos) {
		this.alterarTodosLancamentos = alterarTodosLancamentos;
	}
	
	public void ajustaAlteracaoSeguintes(AjaxBehaviorEvent event){

		if(alterarEsteEPosteriores){
			alterarTodosLancamentos = false;
		}
	}

	public void ajustaAlteracaoTodos(AjaxBehaviorEvent event){
		if(alterarTodosLancamentos){
			alterarEsteEPosteriores = false;
		}
	}

	public Categoria getCategoria() {
		return categoria;
	}

	public void setCategoria(Categoria categoria) {
		this.categoria = categoria;
	}

	public Categoria getCategoriaARemover() {
		return categoriaARemover;
	}

	public void setCategoriaARemover(Categoria categoriaARemover) {
		this.categoriaARemover = categoriaARemover;
	}

    public Long getLancamentoId() {
        return lancamentoId;
    }

    public void setLancamentoId(Long lancamentoId) {
        this.lancamentoId = lancamentoId;
    }
}

src/main/webapp/pages/lancamento/lancamento-simples.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
        xmlns:f="http://java.sun.com/jsf/core"
        xmlns:pretty="http://ocpsoft.com/prettyfaces"
        xmlns:ui="http://java.sun.com/jsf/facelets"
        xmlns:g="http://java.sun.com/jsf/composite/componentes"
		xmlns:h="http://java.sun.com/jsf/html"
        xmlns:p="http://primefaces.org/ui">



<h:panelGroup styleClass="row-fluid">
	<h:form id="form">
		<center>
			<h:panelGroup id="panelLancamento"  styleClass="span12">
				<h:panelGrid columns="2" >
					<div class="row-fluid" >
							<h:outputText value="Tipo"  />
						<div class="span12" >
							<p:selectOneRadio id="tipoLancamentoId" tabindex="1" value="#{lancamentoController.lancamento.tipoLancamento}" converter="enumConverter" style="margin-left: 10px;">
								<f:selectItems value="#{colecoesController.tiposLancamento}" var="t" itemValue="#{t}" 
								itemLabel="#{i.tipo}" />
							</p:selectOneRadio>
						</div>
					</div>
					
					<div class="row-fluid">
							<h:outputText value="Descrição"  />
						<div class="span12">
							<h:inputText tabindex="2" value="#{lancamentoController.lancamento.descricao}" maxlength="64"  style="width: 400px!important;" />
						</div>
					</div>
					
					<div class="row-fluid">
							<h:outputText value="Valor"  />
						<div class="span12">
							<h:inputText tabindex="3" value="#{lancamentoController.lancamento.valor}"  styleClass="currency input-small">
								<f:convertNumber type="currency" locale="pt_BR" maxFractionDigits="2" 
									minFractionDigits="2" />
							</h:inputText>
						</div>
					</div>
					
					<div class="row-fluid">
							<h:outputText value="Data"  />
						<div class="span12">
							<p:calendar tabindex="4" value="#{lancamentoController.lancamento.dataLancamento}" navigator="true"  pattern="dd/MM/yyyy" />
						</div>
					</div>
					<div class="row-fluid" >
						<h:panelGroup id="panelCategoria" styleClass="span12">
							<div class="row-fluid">
								<h:outputText styleClass="span12" value="Categoria" />
								<div class="row-fluid "  style="float: left;">
									<p:selectOneMenu tabindex="5" value="#{lancamentoController.categoria}" converter="viewEntityConverter" filterMatchMode="contains" filter="true">
										<p:ajax update="@this" />
										<f:selectItem itemValue="#{null}" itemLabel="Selecione" />
										<f:selectItems value="#{colecoesController.categorias}" var="c" itemLabel="#{c.nome}" itemValue="#{c}" />
									</p:selectOneMenu>
									<h:commandLink tabindex="6" styleClass="btn" title="Adicionar Categoria" style="height: 19px; margin-top: -20px;" >
										<i class="icon-plus" />
										<f:ajax listener="#{lancamentoController.adicionaCategoria}" event="click" render="panelCategoria" />
									</h:commandLink>
								</div>
							</div>
							<h:panelGrid id="categorias" columns="2" styleClass="row-fluid">
								<ui:repeat var="c" value="#{lancamentoController.lancamento.categorias}" >
									<g:removableLabel categoria="#{c}" controller="#{lancamentoController}"  />
								</ui:repeat>
							</h:panelGrid>
						</h:panelGroup>
					</div>

					<div class="row-fluid">
							<h:outputText value="Modo de pagamento" />
						<div class="span12">
							<p:selectOneMenu tabindex="7" value="#{lancamentoController.lancamento.tipoPagamento}" converter="viewEntityConverter" filterMatchMode="contains" filter="true" >
								<f:selectItems value="#{colecoesController.tiposPagamento}"  var="t" itemLabel="#{t.nome}" itemValue="#{t}"/>
							</p:selectOneMenu>
						</div>
					</div>					
				</h:panelGrid>
	
				<center>
					<h:panelGroup rendered="#{lancamentoController.mostraRepetir}" style="margin-top: 10px;" styleClass="span12">
						<h:outputText value="Repetir ?"  style="padding-right: 7px;" />
						<p:selectBooleanCheckbox tabindex="8" value="#{lancamentoController.repeticao}"  >
							<p:ajax update="panelOpcaoFixoParcelado,panelRepeticao" />
						</p:selectBooleanCheckbox >
					</h:panelGroup>

					<h:panelGroup id="panelOpcaoFixoParcelado" styleClass="span12">
						<h:panelGroup id="panelFixoParcelado"  rendered="#{lancamentoController.repeticao}">
							<p:selectOneRadio tabindex="9" id="tipoParcelamento" value="#{lancamentoController.tipoParcelamentoSelecionado}" converter="enumConverter">
								<f:selectItems value="#{lancamentoController.tiposParcelamento}" var="t" itemValue="#{t}" itemLabel="#{t}" />
								<p:ajax event="change" update="panelRepeticao" /> 
							</p:selectOneRadio>
						</h:panelGroup>
					</h:panelGroup>
					
					<h:panelGroup id="panelRepeticao" styleClass="row-fluid">
						<h:panelGroup id="panelParcelado"  rendered="#{lancamentoController.mostraPanelRepeticaoParcelado}" styleClass="span12">
							<div style="width: 200px;">
								<h:selectOneMenu tabindex="10" style=" width: 60px; float:left"  value="#{lancamentoController.numeroParcelas}" >
									<f:selectItems value="#{colecoesController.numeroParcelas}" var="p"  itemValue="#{p}"/>
								</h:selectOneMenu>
								<h:selectOneMenu tabindex="11" style="display: block; width: 130px" value="#{lancamentoController.lancamento.periodicidadeParcelada}" converter="enumConverter" >
									<f:selectItems value="#{colecoesController.periodicidadeParceladas}" var="p"  itemValue="#{p}"/>
								</h:selectOneMenu>
							</div>
						</h:panelGroup>
						
						<h:panelGroup id="panelFixo" rendered="#{lancamentoController.mostraPanelRepeticaoFixo}" styleClass="span12">
							<h:selectOneMenu tabindex="12"  value="#{lancamentoController.lancamento.periodicidadeFixa}" rendered="#{lancamentoController.mostraPanelRepeticaoFixo}"
								converter="periodicidadeFixaConverter" >
								<f:selectItems value="#{colecoesController.periodicidadeFixas}" var="p"  itemValue="#{p}" itemLabel="#{p.descricao}"/>
							</h:selectOneMenu>
						</h:panelGroup>
					</h:panelGroup>
				</center>
				
				


			</h:panelGroup>
			<div class="row-fluid"  style="margin-top: 10px;">
				<h:commandButton tabindex="13" styleClass="btn btn-primary" value="Salvar"  action="#{lancamentoController.salvar}"  >
				</h:commandButton>
				
			<pretty:link tabindex="14"  mappingId="lancamentos" style="text-decoration: none;" styleClass="btn btn-primary offset1">
				Cancelar
			</pretty:link>
			</div>
		</center>
		<h:panelGroup id="panelAlertaEdicao" styleClass="row-fluid" rendered="#{lancamentoController.edicaoLancamentoParcelado}">
			<div class="span12" style="background: yellow;">
				<center>
					<h:outputLabel value="Este é um lancamento parcelado, que se repete em outras datas" style="font-weight: bold; color: red"/>
				</center>
				<br/>
				<div class="row-fluid">
					<div class="span12">
						<p:selectBooleanCheckbox id="alterarEsteEPosteriores" value="#{lancamentoController.alterarEsteEPosteriores}" style="display: block">
							<p:ajax event="change"  update="panelAlertaEdicao" listener="#{lancamentoController.ajustaAlteracaoSeguintes}"/>
						</p:selectBooleanCheckbox>
						<h:outputLabel for="alterarEsteEPosteriores" value="Alterar apenas este e os seguintes" />
					</div>
				</div>
				<div class="row-fluid">
					<div class="span12">
						<p:selectBooleanCheckbox id="alterarTodosLancamentos" value="#{lancamentoController.alterarTodosLancamentos}" style="display: block">
							<p:ajax event="change"  update="panelAlertaEdicao" listener="#{lancamentoController.ajustaAlteracaoTodos}"/>
						</p:selectBooleanCheckbox>
						<h:outputLabel escape="false" style="font-weight: bold" value="É, tenho certeza! Quero alterar todas, inclusive as anteriores" /> 
					</div>
				</div>
			</div>
		</h:panelGroup>
	</h:form>
</h:panelGroup>

</html>

src/main/webapp/pages/lancamento/lancamento.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
        xmlns:h="http://java.sun.com/jsf/html"
        xmlns:f="http://java.sun.com/jsf/core"
		xmlns:pretty="http://ocpsoft.com/prettyfaces"
        xmlns:ui="http://java.sun.com/jsf/facelets"
        xmlns:g="http://java.sun.com/jsf/composite/componentes"
        xmlns:p="http://primefaces.org/ui">

<ui:composition template="/templates/template.xhtml">

<ui:define name="titulo">Lançamento</ui:define>
<ui:define name="conteudo">

	<ui:include src="/pages/lancamento/lancamento-simples.xhtml" />

</ui:define>

</ui:composition>
</html>